Index: FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/connector/Connector.java
===================================================================
--- FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/connector/Connector.java	(revision 2584)
+++ FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/connector/Connector.java	(revision 2584)
@@ -0,0 +1,135 @@
+/*
+ * FCKeditor - The text editor for Internet - http://www.fckeditor.net
+ * Copyright (C) 2003-2008 Frederico Caldeira Knabben
+ * 
+ * == BEGIN LICENSE ==
+ * 
+ * Licensed under the terms of any of the following licenses at your
+ * choice:
+ * 
+ *  - GNU General Public License Version 2 or later (the "GPL")
+ *    http://www.gnu.org/licenses/gpl.html
+ * 
+ *  - GNU Lesser General Public License Version 2.1 or later (the "LGPL")
+ *    http://www.gnu.org/licenses/lgpl.html
+ * 
+ *  - Mozilla Public License Version 1.1 or later (the "MPL")
+ *    http://www.mozilla.org/MPL/MPL-1.1.html
+ * 
+ * == END LICENSE ==
+ */
+package net.fckeditor.connector;
+
+
+import java.io.InputStream;
+import java.util.List;
+import java.util.Map;
+
+import javax.servlet.ServletContext;
+
+import net.fckeditor.connector.exception.FolderAlreadyExistsException;
+import net.fckeditor.connector.exception.InvalidCurrentFolderException;
+import net.fckeditor.connector.exception.InvalidFolderNameException;
+import net.fckeditor.connector.exception.SecurityIssueException;
+import net.fckeditor.connector.exception.UnknownException;
+import net.fckeditor.handlers.ResourceType;
+
+/**
+ * Interface for all Connectors.<br>
+ * The Connector will be initialized by the {@link Dispatcher}. If an error is happened there are well-defined
+ * exceptions which could be thrown. So the {@link Dispatcher} can react according to it.
+ * <br><br>
+ * Keep in mind that the {@link Dispatcher} verifies the request and redirects the relevant parameters
+ * to the different methods of the connector and forwards the response to {@link ConnectorServlet}.
+ * Therefore you don't need to check the basic parameters 'type' and 'currentFolder' against <code>null</code>.
+ * 
+ * @version $Id$
+ */
+public interface Connector {
+	
+	/**
+	 * This key is to address a file's name in {@link #getFiles(ResourceType, String)} map.
+	 */
+	public final static String KEY_NAME  = "name";
+	/**
+	 * This key is to address a file's size in {@link #getFiles(ResourceType, String)} map.
+	 */
+	public final static String KEY_SIZE = "size";
+	
+	/**
+	 * Initializes the connector. This method will be called on the start of the webapp.
+	 * 
+	 * @param servletContext eg. to get the real path of a file for example.
+	 */
+	public void init(final ServletContext servletContext);
+
+	/**
+	 * Returns a list of file attributes. which are inside the abstract path
+	 * <code>/[type-folder]/[currentFolder]</code>.
+	 * Filename, file size (in bytes).
+	 * 
+	 * @param type
+	 * @param currentFolder
+	 * @return A list of folder names.
+	 * @throws InvalidCurrentFolderException
+	 * @throws SecurityIssueException
+	 * @throws UnknownException
+	 */
+	public List<Map<String, Object>> getFiles(final ResourceType type, final String currentFolder)
+		throws InvalidCurrentFolderException, SecurityIssueException, UnknownException;
+	
+	/**
+	 * Returns a list of folders which are inside the abstract path
+	 * <code>/[type-folder]/[currentFolder]</code>.
+	 * 
+	 * @param type
+	 * @param currentFolder
+	 * @return A list of file names.
+	 * @throws InvalidCurrentFolderException
+	 * @throws SecurityIssueException
+	 * @throws UnknownException
+	 */
+	public List<String> getFolders(final ResourceType type, final String currentFolder)
+		throws InvalidCurrentFolderException, SecurityIssueException, UnknownException;
+		
+	/**
+	 * Creates a new folder inside inside the abstract path
+	 * <code>/[type-folder]/[currentFolder]</code>.
+	 * 
+	 * @param type
+	 * @param currentFolder
+	 * @param newFolder Name of the new folder to create.
+	 * @throws InvalidCurrentFolderException
+	 * @throws SecurityIssueException
+	 * @throws InvalidFolderNameException
+	 * @throws FolderAlreadyExistsException
+	 */
+	public void createFolder(final ResourceType type, final String currentFolder, final String newFolder) 
+		throws InvalidCurrentFolderException, SecurityIssueException, InvalidFolderNameException, FolderAlreadyExistsException;
+
+	/**
+	 * Uploads a new file into the abstract path <code>/[type-folder]/[currentFolder]</code>. If there is 
+	 * already a file with the same name, the new one has to renamed.
+	 * 
+	 * @param type
+	 * @param currentFolder
+	 * @param fileName
+	 * @param inputStream Content of the file.
+	 * @return <code>fileName</code> or the name of the renamed file.
+	 * @throws InvalidCurrentFolderException
+	 * @throws SecurityIssueException
+	 */
+	public String fileUpload(final ResourceType type, final String currentFolder, final String fileName, final InputStream inputStream)
+		throws InvalidCurrentFolderException, SecurityIssueException;
+	
+	/**
+	 * Uploads a new file into the top of <code>userFiles</code>. If there is 
+	 * already a file with the same name, the new one has to renamed.
+	 * 
+	 * @param fileName
+	 * @param inputStream Content of the file.
+	 * @return
+	 * @throws SecurityIssueException
+	 */
+	public String quickUpload(final String fileName, final InputStream inputStream) throws SecurityIssueException;
+}
Index: FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/connector/ConnectorServlet.java
===================================================================
--- FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/connector/ConnectorServlet.java	(revision 2578)
+++ FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/connector/ConnectorServlet.java	(revision 2584)
@@ -21,8 +21,5 @@
 package net.fckeditor.connector;
 
-import java.io.File;
 import java.io.IOException;
-import java.io.PrintWriter;
-import java.util.List;
 
 import javax.servlet.ServletException;
@@ -31,297 +28,79 @@
 import javax.servlet.http.HttpServletResponse;
 
-import net.fckeditor.handlers.CommandHandler;
-import net.fckeditor.handlers.ConnectorHandler;
-import net.fckeditor.handlers.ExtensionsHandler;
-import net.fckeditor.handlers.LocalizedPropertiesLoader;
-import net.fckeditor.handlers.RequestCycleHandler;
-import net.fckeditor.handlers.ResourceTypeHandler;
-import net.fckeditor.response.UploadResponse;
-import net.fckeditor.response.XmlResponse;
-import net.fckeditor.tool.Utils;
-import net.fckeditor.tool.UtilsFile;
-import net.fckeditor.tool.UtilsResponse;
-
-import org.apache.commons.fileupload.FileItem;
-import org.apache.commons.fileupload.FileItemFactory;
-import org.apache.commons.fileupload.disk.DiskFileItemFactory;
-import org.apache.commons.fileupload.servlet.ServletFileUpload;
-import org.apache.commons.io.FilenameUtils;
-import org.slf4j.Logger;
-import org.slf4j.LoggerFactory;
+import net.fckeditor.requestcycle.ThreadLocalData;
 
 /**
- * Servlet to upload and browse files.<br />
- * 
- * This servlet accepts 4 commands which interact with the server-side
- * filesystem.<br />
- * The allowed commands are:
+ * This is the FCKeditor Connector servlet. It has the following jobs:
  * <ul>
- * <li><code>GetFolders</code>: Retrieves a list of folders in the current
- * folder</li>
- * <li><code>GetFoldersAndFiles</code>: Retrieves a list of files and
- * folders in the current folder</li>
- * <li><code>CreateFolder</code>: Creates a new folder in the current folder</li>
- * <li><code>FileUpload</code>: Stores an uploaded file into the current
- * folder. (must be sent with POST)</li>
- * </ul>
+ * <li>Initialization of the {@link Dispatcher} object.</li>
+ * <li>Calling {@link ThreadLocalData#beginRequest(HttpServletRequest)}
+ * (It is an object that holds request-based objects.)</li>
+ * <li>Forwarding the requests:
+ * 	<ul><li><code>GET</code> to {@link Dispatcher#doGet(HttpServletRequest, HttpServletResponse)} </li>
+ * 		<li><code>POST</code> to {@link Dispatcher#doPost(HttpServletRequest, HttpServletResponse)}.</li>
+ *  </ul></li>
+ * <li>Calling {@link ThreadLocalData#endRequest()} to cleanup all ThreadLocal
+ * objects independent of if an exception was thrown or not. That's very
+ * important to prevent memory-leaks!!!</li>
+ * </ul><br>
+ * Summing up: This workflow guarantees the correct initialization and cleaning
+ * of the {@link ThreadLocalData}, - it's essential because of preventing memory-leaks. 
+ * All requests are dispatched to the {@link Dispatcher}. The {@link Dispatcher} 
+ * forwards the request to an implementation of the {@link Connector}.
  * 
  * @version $Id$
  */
 public class ConnectorServlet extends HttpServlet {
-
 	private static final long serialVersionUID = -5742008970929377161L;
-	private static final Logger logger = LoggerFactory
-			.getLogger(ConnectorServlet.class);
-
+	private Dispatcher dispatcher;
+	
 	/**
-	 * Initialize the servlet: <code>mkdir</code> &lt;DefaultUserFilesPath&gt;
+	 * Initializes the {@link Dispatcher}.
+	 * 
+	 * @see javax.servlet.GenericServlet#init()
 	 */
-	public void init() throws ServletException, IllegalArgumentException {
-		String realDefaultUserFilesPath = getServletContext().getRealPath(
-				ConnectorHandler.getDefaultUserFilesPath());
-
-		File defaultUserFilesDir = new File(realDefaultUserFilesPath);
-		UtilsFile.checkDirAndCreate(defaultUserFilesDir);
-
-		logger.info("ConnectorServlet successfully initialized!");
+	@Override
+	public void init() throws ServletException {
+		dispatcher = new Dispatcher(getServletContext());
+	}
+	
+	/* (non-Javadoc)
+	 * @see javax.servlet.http.HttpServlet#doGet(javax.servlet.http.HttpServletRequest, javax.servlet.http.HttpServletResponse)
+	 */
+	@Override
+	protected void doGet(final HttpServletRequest request, final HttpServletResponse response)
+			throws ServletException, IOException {
+		try {
+			ThreadLocalData.beginRequest(request);
+			dispatcher.doGet(request, response);
+		} catch (Exception e) {
+			// if an exception wasn't catched by the Dispatcher, it is a fatal one and has to re-thrown.
+			if (e instanceof IOException)
+				throw (IOException) e;
+			else
+				throw new ServletException(e);
+		} finally {
+			ThreadLocalData.endRequest();
+		}		
 	}
 
-	/**
-	 * Manage the <code>GET</code> requests (<code>GetFolders</code>,
-	 * <code>GetFoldersAndFiles</code>, <code>CreateFolder</code>).<br/>
-	 * 
-	 * The servlet accepts commands sent in the following format:<br/>
-	 * <code>connector?Command=&lt;CommandName&gt;&Type=&lt;ResourceType&gt;&CurrentFolder=&lt;FolderPath&gt;</code>
-	 * <p>
-	 * It executes the commands and then returns the result to the client in XML
-	 * format.
-	 * </p>
+	/* (non-Javadoc)
+	 * @see javax.servlet.http.HttpServlet#doPost(javax.servlet.http.HttpServletRequest, javax.servlet.http.HttpServletResponse)
 	 */
-	public void doGet(HttpServletRequest request, HttpServletResponse response)
+	@Override
+	protected void doPost(final HttpServletRequest request, final HttpServletResponse response)
 			throws ServletException, IOException {
-		logger.debug("Entering ConnectorServlet#doGet");
-
-		response.setCharacterEncoding("UTF-8");
-		response.setContentType("application/xml; charset=UTF-8");
-		response.setHeader("Cache-Control", "no-cache");
-		PrintWriter out = response.getWriter();
-
-		String commandStr = request.getParameter("Command");
-		String typeStr = request.getParameter("Type");
-		String currentFolderStr = request.getParameter("CurrentFolder");
-
-		logger.debug("Parameter Command: {}", commandStr);
-		logger.debug("Parameter Type: {}", typeStr);
-		logger.debug("Parameter CurrentFolder: {}", currentFolderStr);
-
-		XmlResponse xr;
-		LocalizedPropertiesLoader lpl = LocalizedPropertiesLoader.getInstance(request);
-
-		// FIXME check for isEnabledForFolderCreation
-		if (!RequestCycleHandler.isEnabledForFileBrowsing(request))
-			xr = new XmlResponse(XmlResponse.EN_ERROR, lpl
-					.getFileBrowsingDisabled());
-		else if (!CommandHandler.isValidForGet(commandStr))
-			xr = new XmlResponse(XmlResponse.EN_ERROR, lpl.getInvalidCommand());
-		else if (typeStr != null && !ResourceTypeHandler.isValid(typeStr))
-			xr = new XmlResponse(XmlResponse.EN_ERROR, lpl.getInvalidType());
-		else if (!UtilsFile.isValidPath(currentFolderStr))
-			xr = new XmlResponse(XmlResponse.EN_ERROR, lpl
-					.getInvalidCurrentFolder());
-		else {
-			CommandHandler command = CommandHandler.getCommand(commandStr);
-			ResourceTypeHandler resourceType = ResourceTypeHandler
-					.getDefaultResourceType(typeStr);
-
-			String typePath = UtilsFile.constructServerSidePath(request,
-					resourceType);
-			String typeDirPath = getServletContext().getRealPath(typePath);
-
-			File typeDir = new File(typeDirPath);
-			UtilsFile.checkDirAndCreate(typeDir);
-
-			File currentDir = new File(typeDir, currentFolderStr);
-
-			if (!currentDir.exists())
-				xr = new XmlResponse(XmlResponse.EN_INVALID_FOLDER_NAME);
-			else {
-
-				xr = new XmlResponse(command, resourceType, currentFolderStr,
-						UtilsResponse.constructResponseUrl(request,
-								resourceType, currentFolderStr, ConnectorHandler.isFullUrl()));
-
-				if (command.equals(CommandHandler.GET_FOLDERS))
-					xr.setFolders(currentDir);
-				else if (command.equals(CommandHandler.GET_FOLDERS_AND_FILES))
-					xr.setFoldersAndFiles(currentDir);
-				else if (command.equals(CommandHandler.CREATE_FOLDER)) {
-					String newFolderStr = UtilsFile.sanitizeFolderName(request
-							.getParameter("NewFolderName"));
-					logger.debug("Parameter NewFolderName: {}", newFolderStr);
-
-					File newFolder = new File(currentDir, newFolderStr);
-					int errorNumber = XmlResponse.EN_UKNOWN;
-
-					if (newFolder.exists())
-						errorNumber = XmlResponse.EN_ALREADY_EXISTS;
-					else {
-						try {
-							errorNumber = (newFolder.mkdir()) ? XmlResponse.EN_OK
-									: XmlResponse.EN_INVALID_FOLDER_NAME;
-						} catch (SecurityException e) {
-							errorNumber = XmlResponse.EN_SECURITY_ERROR;
-						}
-					}
-					xr.setError(errorNumber);
-				}
-			}
+		try {
+			ThreadLocalData.beginRequest(request);
+			dispatcher.doPost(request, response);
+		} catch (Exception e) {
+			// if an exception wasn't catched by the Dispatcher, it is a fatal one and has to re-thrown.
+			if (e instanceof IOException)
+				throw new IOException(e.getLocalizedMessage());
+			else
+				throw new ServletException(e);
+		} finally {
+			ThreadLocalData.endRequest();
 		}
-
-		out.print(xr);
-		out.flush();
-		out.close();
-		logger.debug("Exiting ConnectorServlet#doGet");
-	}
-
-	/**
-	 * Manage the <code>POST</code> requests (<code>FileUpload</code>).<br />
-	 * 
-	 * The servlet accepts commands sent in the following format:<br />
-	 * <code>connector?Command=&lt;FileUpload&gt;&Type=&lt;ResourceType&gt;&CurrentFolder=&lt;FolderPath&gt;</code>
-	 * with the file in the <code>POST</code> body.<br />
-	 * <br>
-	 * It stores an uploaded file (renames a file if another exists with the
-	 * same name) and then returns the JavaScript callback.
-	 */
-	@SuppressWarnings("unchecked")
-	public void doPost(HttpServletRequest request, HttpServletResponse response)
-			throws ServletException, IOException {
-		logger.debug("Entering Connector#doPost");
-
-		response.setCharacterEncoding("UTF-8");
-		response.setContentType("text/html; charset=UTF-8");
-		response.setHeader("Cache-Control", "no-cache");
-		PrintWriter out = response.getWriter();
-
-		String commandStr = request.getParameter("Command");
-		String typeStr = request.getParameter("Type");
-		String currentFolderStr = request.getParameter("CurrentFolder");
-
-		logger.debug("Parameter Command: {}", commandStr);
-		logger.debug("Parameter Type: {}", typeStr);
-		logger.debug("Parameter CurrentFolder: {}", currentFolderStr);
-
-		UploadResponse ur;
-		LocalizedPropertiesLoader lpl = LocalizedPropertiesLoader.getInstance(request);
-
-		// if this is a QuickUpload request, 'commandStr' and 'currentFolderStr'
-		// are empty
-		if (Utils.isEmpty(commandStr) && Utils.isEmpty(currentFolderStr)) {
-			commandStr = "QuickUpload";
-			currentFolderStr = "/";
-		}
-
-		if (!RequestCycleHandler.isEnabledForFileUpload(request))
-			ur = new UploadResponse(UploadResponse.SC_SECURITY_ERROR, null,
-					null, lpl.getFileBrowsingDisabled());
-		else if (!CommandHandler.isValidForPost(commandStr))
-			ur = new UploadResponse(UploadResponse.SC_ERROR, null, null, lpl
-					.getInvalidCommand());
-		else if (typeStr != null && !ResourceTypeHandler.isValid(typeStr))
-			ur = new UploadResponse(UploadResponse.SC_ERROR, null, null, lpl
-					.getInvalidType());
-		else if (!UtilsFile.isValidPath(currentFolderStr))
-			ur = new UploadResponse(UploadResponse.SC_ERROR, null, null, lpl
-					.getInvalidCurrentFolder());
-		else {
-			ResourceTypeHandler resourceType = ResourceTypeHandler
-					.getDefaultResourceType(typeStr);
-
-			String typePath = UtilsFile.constructServerSidePath(request,
-					resourceType);
-			String typeDirPath = getServletContext().getRealPath(typePath);
-
-			File typeDir = new File(typeDirPath);
-			UtilsFile.checkDirAndCreate(typeDir);
-
-			File currentDir = new File(typeDir, currentFolderStr);
-
-			if (!currentDir.exists())
-				ur = new UploadResponse(UploadResponse.SC_ERROR, null, null,
-						lpl.getInvalidCurrentFolder());
-			else {
-
-				String newFilename = null;
-				FileItemFactory factory = new DiskFileItemFactory();
-				ServletFileUpload upload = new ServletFileUpload(factory);
-
-				try {
-
-					List<FileItem> items = upload.parseRequest(request);
-
-					// We upload only one file at the same time
-					FileItem uplFile = items.get(0);
-					String rawName = UtilsFile.sanitizeFileName(uplFile
-							.getName());
-					String filename = FilenameUtils.getName(rawName);
-					String baseName = FilenameUtils.removeExtension(filename);
-					String extension = FilenameUtils.getExtension(filename);
-
-					if (!ExtensionsHandler.isAllowed(resourceType, extension))
-						ur = new UploadResponse(
-								UploadResponse.SC_INVALID_EXTENSION);
-					else {
-
-						// construct an unique file name
-						File pathToSave = new File(currentDir, filename);
-						int counter = 1;
-						while (pathToSave.exists()) {
-							newFilename = baseName.concat("(").concat(
-									String.valueOf(counter)).concat(")")
-									.concat(".").concat(extension);
-							pathToSave = new File(currentDir, newFilename);
-							counter++;
-						}
-
-						if (Utils.isEmpty(newFilename))
-							ur = new UploadResponse(UploadResponse.SC_OK,
-									UtilsResponse.constructResponseUrl(request,
-											resourceType, currentFolderStr,
-											ConnectorHandler.isFullUrl())
-											.concat(filename));
-						else
-							ur = new UploadResponse(UploadResponse.SC_RENAMED,
-									UtilsResponse.constructResponseUrl(request,
-											resourceType, currentFolderStr,
-											ConnectorHandler.isFullUrl())
-											.concat(newFilename), newFilename);
-
-						// secure image check
-						if (resourceType.equals(ResourceTypeHandler.IMAGE)
-								&& ConnectorHandler.isSecureImageUploads()) {
-							if (UtilsFile.isImage(uplFile.getInputStream()))
-								uplFile.write(pathToSave);
-							else {
-								uplFile.delete();
-								ur = new UploadResponse(
-										UploadResponse.SC_INVALID_EXTENSION);
-							}
-						} else
-							uplFile.write(pathToSave);
-
-					}
-				} catch (Exception e) {
-					ur = new UploadResponse(UploadResponse.SC_SECURITY_ERROR);
-				}
-			}
-
-		}
-
-		out.print(ur);
-		out.flush();
-		out.close();
-
-		logger.debug("Exiting Connector#doPost");
 	}
 
Index: FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/connector/Dispatcher.java
===================================================================
--- FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/connector/Dispatcher.java	(revision 2584)
+++ FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/connector/Dispatcher.java	(revision 2584)
@@ -0,0 +1,270 @@
+/*
+ * FCKeditor - The text editor for Internet - http://www.fckeditor.net
+ * Copyright (C) 2003-2008 Frederico Caldeira Knabben
+ * 
+ * == BEGIN LICENSE ==
+ * 
+ * Licensed under the terms of any of the following licenses at your
+ * choice:
+ * 
+ *  - GNU General Public License Version 2 or later (the "GPL")
+ *    http://www.gnu.org/licenses/gpl.html
+ * 
+ *  - GNU Lesser General Public License Version 2.1 or later (the "LGPL")
+ *    http://www.gnu.org/licenses/lgpl.html
+ * 
+ *  - Mozilla Public License Version 1.1 or later (the "MPL")
+ *    http://www.mozilla.org/MPL/MPL-1.1.html
+ * 
+ * == END LICENSE ==
+ */
+package net.fckeditor.connector;
+
+import java.io.IOException;
+import java.io.PrintWriter;
+import java.util.List;
+
+import javax.servlet.ServletContext;
+import javax.servlet.http.HttpServletRequest;
+import javax.servlet.http.HttpServletResponse;
+
+import net.fckeditor.connector.exception.FolderAlreadyExistsException;
+import net.fckeditor.connector.exception.InvalidCurrentFolderException;
+import net.fckeditor.connector.exception.InvalidFolderNameException;
+import net.fckeditor.connector.exception.SecurityIssueException;
+import net.fckeditor.connector.exception.UnknownException;
+import net.fckeditor.handlers.CommandHandler;
+import net.fckeditor.handlers.ConnectorHandler;
+import net.fckeditor.handlers.ExtensionsHandler;
+import net.fckeditor.handlers.RequestCycleHandler;
+import net.fckeditor.handlers.ResourceType;
+import net.fckeditor.requestcycle.Context;
+import net.fckeditor.requestcycle.ThreadLocalData;
+import net.fckeditor.response.GetResponse;
+import net.fckeditor.response.UploadResponse;
+import net.fckeditor.tool.Utils;
+import net.fckeditor.tool.UtilsFile;
+
+import org.apache.commons.fileupload.FileItem;
+import org.apache.commons.fileupload.FileItemFactory;
+import org.apache.commons.fileupload.disk.DiskFileItemFactory;
+import org.apache.commons.fileupload.servlet.ServletFileUpload;
+import org.apache.commons.io.FilenameUtils;
+import org.slf4j.Logger;
+import org.slf4j.LoggerFactory;
+
+
+/**
+ * This class is calling by {@link ConnectorServlet}. It verifies the request parameters 
+ * and forward it to the corresponding {@link Connector} methods. If errors are happened inside these methods,
+ * well defined exceptions from {@link net.fckeditor.connector.exception} will be thrown. These exceptions or the return
+ * values of {@link Connector} methods will be transfered to the HttpServletResponse object.
+ * 
+ * @version $Id$
+ */
+public class Dispatcher {
+	private static final Logger logger = LoggerFactory.getLogger(Dispatcher.class);
+	private Connector connector = null;
+	
+	/**
+	 * Initializes the {@link Connector}.
+	 * 
+	 * @param servletContext
+	 */
+	protected Dispatcher(final ServletContext servletContext) {
+		this.connector = ConnectorHandler.getConnector();
+		this.connector.init(servletContext);
+	}
+	
+	
+	/**
+	 * Manage the <code>GET</code> requests (<code>GetFolders</code>,
+	 * <code>GetFoldersAndFiles</code>, <code>CreateFolder</code>).<br/>
+	 * 
+	 * The method accepts commands sent in the following format:<br/>
+	 * <code>connector?Command=&lt;CommandName&gt;&Type=&lt;ResourceType&gt;&CurrentFolder=&lt;FolderPath&gt;</code>
+	 * <p>
+	 * It executes the relevant commands and then returns the result to the client in XML
+	 * format.
+	 * </p>
+	 */
+	public void doGet(final HttpServletRequest request, final HttpServletResponse response) throws IOException {
+		logger.debug("Entering Dispatcher#doGet");
+		Context context = ThreadLocalData.getContext();
+
+		response.setCharacterEncoding("UTF-8");
+		response.setContentType("application/xml; charset=UTF-8");
+		response.setHeader("Cache-Control", "no-cache");
+		PrintWriter out = response.getWriter();
+
+		context.logBaseParameters();
+		
+		GetResponse getResponse = null;
+		// check parameters
+		// TODO should we move the parameter check to Context -> throws an exception?
+		if (!CommandHandler.isValidForGet(context.getCommandStr()))
+			getResponse = GetResponse.getErrorInvalidCommand();
+		else if (!ResourceType.isValid(context.getTypeStr()))
+			getResponse = GetResponse.getErrorInvalidType();
+		else if (!UtilsFile.isValidPath(context.getCurrentFolderStr()))
+			getResponse = GetResponse.getErrorInvalidCurrentFolder();
+		else {
+			
+			ResourceType type = context.getDefaultResourceType();
+			CommandHandler command = context.getCommand();
+			
+			// check permissions for user action
+			if ((command.equals(CommandHandler.GET_FOLDERS) || command.equals(CommandHandler.GET_FOLDERS_AND_FILES))
+					&& !RequestCycleHandler.isEnabledForFileBrowsing())
+				getResponse = GetResponse.getErrorFileBrowsingDisabled();
+			else if (command.equals(CommandHandler.CREATE_FOLDER) && !RequestCycleHandler.isEnabledForFolderCreation())
+				getResponse = GetResponse.getErrorFolderCreationDisabled();
+			
+			else {
+				
+				// make the connector calls, catch its exceptions and generate the right response object
+				try {
+					if (command.equals(CommandHandler.CREATE_FOLDER)) {
+						String newFolderStr = UtilsFile.sanitizeFolderName(request.getParameter("NewFolderName"));
+						if (Utils.isEmpty(newFolderStr))
+							getResponse = GetResponse.getErrorInvalidFolderName();
+						else {
+							logger.debug("Parameter NewFolderName: {}", newFolderStr);
+							connector.createFolder(type, context.getCurrentFolderStr(), newFolderStr);
+							getResponse = GetResponse.getOK();
+						}
+					} else if (command.equals(CommandHandler.GET_FOLDERS) || command.equals(CommandHandler.GET_FOLDERS_AND_FILES)) {
+						// TODO I don't like this code, it has to be more generic
+						String responseUrl = context.buildUrl(ConnectorHandler.getUserFilesPath());
+						getResponse = getFoldersAndFiles(command, type, context.getCurrentFolderStr(), responseUrl); 
+					} else 
+						getResponse = GetResponse.getErrorUnknown();
+				} catch (InvalidCurrentFolderException e) {
+					getResponse = GetResponse.getErrorInvalidCurrentFolder();
+				} catch (SecurityIssueException e) {
+					getResponse = GetResponse.getErrorSecurity();
+				} catch (InvalidFolderNameException e) {
+					getResponse = GetResponse.getErrorInvalidFolderName();
+				} catch (FolderAlreadyExistsException e) {
+					getResponse = GetResponse.getErrorFolderAlreadyExists();
+				} catch (Exception e) {
+					getResponse = GetResponse.getErrorUnknown();
+				}
+			}
+		}
+		
+		out.print(getResponse);
+		out.flush();
+		out.close();
+		logger.debug("Exiting Dispatcher#doGet");
+	}
+	
+	/**
+	 * Helper to make the right {@link Connector}-calls for <code>GetFolders</code> and
+	 * <code>GetFoldersAndFiles</code>.
+	 * 
+	 * @param command should be only {@link CommandHandler#GET_FOLDERS} or {@link CommandHandler#GET_FOLDERS_AND_FILES}!!
+	 * @param type
+	 * @param currentFolderStr
+	 * @param responseUrl
+	 * @return
+	 * @throws InvalidCurrentFolderException
+	 * @throws SecurityIssueException
+	 * @throws UnknownException
+	 */
+	private GetResponse getFoldersAndFiles(final CommandHandler command, final ResourceType type, final String currentFolderStr, final String responseUrl)
+			throws InvalidCurrentFolderException, SecurityIssueException, UnknownException {
+		GetResponse getResponse = new GetResponse(command, type, currentFolderStr, responseUrl);
+		getResponse.setFolders(connector.getFolders(type, currentFolderStr));
+		if (command.equals(CommandHandler.GET_FOLDERS_AND_FILES)) 
+			getResponse.setFiles(connector.getFiles(type, currentFolderStr));
+		return getResponse;
+	}
+	
+	/**
+	 * Manage the <code>POST</code> requests (<code>FileUpload</code>).<br />
+	 * 
+	 * The method accepts commands sent in the following format:<br />
+	 * <code>connector?Command=&lt;FileUpload&gt;&Type=&lt;ResourceType&gt;&CurrentFolder=&lt;FolderPath&gt;</code>
+	 * with the file in the <code>POST</code> body.<br />
+	 * <br>
+	 * The Connector stores an uploaded file (renames a file if another exists with the
+	 * same name) and then returns the JavaScript callback.
+	 * @throws IOException 
+	 */
+	public void doPost(final HttpServletRequest request, final HttpServletResponse response) throws IOException {
+		logger.debug("Entering Dispatcher#doPost");
+		Context context = ThreadLocalData.getContext();
+		
+		response.setCharacterEncoding("UTF-8");
+		response.setContentType("text/html; charset=UTF-8");
+		response.setHeader("Cache-Control", "no-cache");
+		PrintWriter out = response.getWriter();
+
+		context.logBaseParameters();
+		
+		// if this is a QuickUpload request, 'commandStr' and 'currentFolderStr'
+		// are empty
+		boolean isQuickUpload = context.checkQuickUpload();
+		
+		UploadResponse uploadResponse;
+		// check permissions for user actions
+		if (!RequestCycleHandler.isEnabledForFileUpload())
+			uploadResponse = UploadResponse.getErrorFileUploadDisabled();
+
+		// check parameters  
+		// TODO should we move the parameter check to Context -> throws an exception?
+		else if (!CommandHandler.isValidForPost(context.getCommandStr()))
+			uploadResponse = UploadResponse.getErrorInvalidCommand();
+		else if (!isQuickUpload && !ResourceType.isValid(context.getTypeStr()))
+			uploadResponse = UploadResponse.getErrorInvalidType();
+		else if (!UtilsFile.isValidPath(context.getCurrentFolderStr()))
+			uploadResponse = UploadResponse.getErrorInvalidCurrentFolder();
+		else {
+
+			// call the Connector#fileUpload
+			ResourceType type = context.getDefaultResourceType();
+			FileItemFactory factory = new DiskFileItemFactory();
+			ServletFileUpload upload = new ServletFileUpload(factory);
+			try {
+				@SuppressWarnings("unchecked") List<FileItem> items = upload.parseRequest(request);
+				// We upload just one file at the same time
+				FileItem uplFile = items.get(0);
+				// check the extension (can't be done if QuickUpload)
+				if (!isQuickUpload && !ExtensionsHandler.isAllowed(type, FilenameUtils.getExtension(uplFile.getName())))
+					uploadResponse = UploadResponse.getErrorInvalidExtension();
+				// Secure image check (can't be done if QuickUpload)
+				else if (!isQuickUpload && type.equals(ResourceType.IMAGE) && ConnectorHandler.isSecureImageUploads() && !UtilsFile.isImage(uplFile.getInputStream())) {
+					uploadResponse = UploadResponse.getErrorInvalidExtension();
+				} else {
+					String fileName = FilenameUtils.getName(UtilsFile.sanitizeFileName(uplFile.getName()));
+					String newFileName;
+					if (isQuickUpload) {
+						newFileName = connector.quickUpload(fileName, uplFile.getInputStream());
+					} else {
+						newFileName = connector.fileUpload(type, context.getCurrentFolderStr(), fileName, uplFile.getInputStream());
+					}
+					// TODO I don't like this either
+					String responseUrl = context.buildUrl(ConnectorHandler.getUserFilesPath());
+					if (fileName.equals(newFileName))
+						uploadResponse = new UploadResponse(UploadResponse.SC_OK, responseUrl);
+					else
+						uploadResponse =  new UploadResponse(UploadResponse.SC_RENAMED, responseUrl, newFileName); 
+				}
+				uplFile.delete();
+			} catch (InvalidCurrentFolderException e) {
+				uploadResponse = UploadResponse.getErrorInvalidCurrentFolder();
+			} catch (SecurityIssueException e) {
+				uploadResponse = UploadResponse.getErrorSecurity();
+			} catch (Exception e) {
+				uploadResponse = UploadResponse.getErrorSecurity();
+			}
+		}
+		out.print(uploadResponse);
+		out.flush();
+		out.close();
+		logger.debug("Exiting Dispatcher#doPost");
+	}
+	
+	
+}
